# Introduction

### 

First of all, thank you for your interest to contribute to the Cryptoexchange project.

There are many ways to contribute! Our documentation surely has room for improvement, bug hunting, bug fixing, writing better walkthrough tutorials for our users, and even feature implementations (new exchange, new APIs).

# Ground Rules
* Write specs (even though our integration test is currently brittle, passing specs for your implementation is highly recommended)
* Verify that the data attribute assignment from the API response is correct (ie. base, target, volume is selected correctly)
* Be welcoming to newcomers and encourage diverse new contributors from all backgrounds.
* Keep changes as small as possible, one branch one feature
* Create issues for any major changes and enhancements that you wish to make. Discuss things transparently and get community feedback.

# Getting started
1. Create a fork of this repository on Github
2. You may create a new branch within your fork (name the branch according to the implementation)
3. If you like the change and think the project could use it:
    * Be sure you have followed the code style for the project.
    * Send a pull request indicating that you have a CLA on file.

# Implementing a new exchange
We have a [step by step guide](https://github.com/coingecko/cryptoexchange/wiki/Implementing-a-New-Exchange).
That guide may be useful in helping you understand how we structure our classes to adapt to new exchanges.

# How to suggest a feature or enhancement
If you have any suggestion on how we can make this gem better, feel free to open an issue for discussion.

# Community
You can chat with the core team member or other participating in this repository chat on [https://gitter.im/cryptoexchange-api/Lobby/~chat#](https://gitter.im/cryptoexchange-api/Lobby/~chat#)